<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head profile="http://dublincore.org/documents/2008/08/04/dc-html/">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta name="robots" content="index,follow" />
    <meta name="creator" content="rfcmarkup version 1.119" />
    <link rel="schema.DC" href="http://purl.org/dc/elements/1.1/" />
<meta name="DC.Relation.Replaces" content="rfc6122" />
<meta name="DC.Identifier" content="urn:ietf:rfc:7622" />
<meta name="DC.Date.Issued" content="September, 2015" />
<meta name="DC.Creator" content="Peter Saint-Andre &lt;peter@andyet.com&gt;" />
<meta name="DC.Description.Abstract" content="This document defines the address format for the Extensible Messaging
and Presence Protocol (XMPP), including support for code points
outside the ASCII range. This document obsoletes RFC 6122." />
<meta name="DC.Title" content="Extensible Messaging and Presence Protocol (XMPP): Address Format" />

    <link rel="icon" href="/images/rfc.png" type="image/png" />
    <link rel="shortcut icon" href="/images/rfc.png" type="image/png" />
    <title>RFC 7622 - Extensible Messaging and Presence Protocol (XMPP): Address Format</title>
    
    
    <style type="text/css">
	@media only screen 
	  and (min-width: 992px)
	  and (max-width: 1199px) {
	    body { font-size: 14pt; }
            div.content { width: 96ex; margin: 0 auto; }
        }
	@media only screen 
	  and (min-width: 768px)
	  and (max-width: 991px) {
            body { font-size: 14pt; }
            div.content { width: 96ex; margin: 0 auto; }
        }
	@media only screen 
	  and (min-width: 480px)
	  and (max-width: 767px) {
            body { font-size: 11pt; }
            div.content { width: 96ex; margin: 0 auto; }
        }
	@media only screen 
	  and (max-width: 479px) {
            body { font-size: 8pt; }
            div.content { width: 96ex; margin: 0 auto; }
        }
	@media only screen 
	  and (min-device-width : 375px) 
	  and (max-device-width : 667px) {
            body { font-size: 9.5pt; }
            div.content { width: 96ex; margin: 0 1px; }
        }
	@media only screen 
	  and (min-device-width: 1200px) {
            body { font-size: 10pt; margin: 0 4em; }
            div.content { width: 96ex; margin: 0; }
        }
        h1, h2, h3, h4, h5, h6, .h1, .h2, .h3, .h4, .h5, .h6 {
	    font-weight: bold;
            line-height: 0pt;
            display: inline;
            white-space: pre;
            font-family: monospace;
            font-size: 1em;
	    font-weight: bold;
        }
        pre {
            font-size: 1em;
            margin-top: 0px;
            margin-bottom: 0px;
        }
	.pre {
	    white-space: pre;
	    font-family: monospace;
	}
	.header{
	    font-weight: bold;
	}
        .newpage {
            page-break-before: always;
        }
        .invisible {
            text-decoration: none;
            color: white;
        }
        a.selflink {
          color: black;
          text-decoration: none;
        }
        @media print {
            body {
                font-family: monospace;
                font-size: 10.5pt;
            }
            h1, h2, h3, h4, h5, h6 {
                font-size: 1em;
            }
        
            a:link, a:visited {
                color: inherit;
                text-decoration: none;
            }
            .noprint {
                display: none;
            }
        }
	@media screen {
	    .grey, .grey a:link, .grey a:visited {
		color: #777;
	    }
            .docinfo {
                background-color: #EEE;
            }
            .top {
                border-top: 7px solid #EEE;
            }
            .bgwhite  { background-color: white; }
            .bgred    { background-color: #F44; }
            .bggrey   { background-color: #666; }
            .bgbrown  { background-color: #840; }            
            .bgorange { background-color: #FA0; }
            .bgyellow { background-color: #EE0; }
            .bgmagenta{ background-color: #F4F; }
            .bgblue   { background-color: #66F; }
            .bgcyan   { background-color: #4DD; }
            .bggreen  { background-color: #4F4; }

            .legend   { font-size: 90%; }
            .cplate   { font-size: 70%; border: solid grey 1px; }
	}
    </style>
    <!--[if IE]>
    <style>
    body {
       font-size: 13px;
       margin: 10px 10px;
    }
    </style>
    <![endif]-->

    <script type="text/javascript"><!--
    function addHeaderTags() {
	var spans = document.getElementsByTagName("span");
	for (var i=0; i < spans.length; i++) {
	    var elem = spans[i];
	    if (elem) {
		var level = elem.getAttribute("class");
                if (level == "h1" || level == "h2" || level == "h3" || level == "h4" || level == "h5" || level == "h6") {
                    elem.innerHTML = "<"+level+">"+elem.innerHTML+"</"+level+">";		
                }
	    }
	}
    }
    var legend_html = "Colour legend:<br />      <table>         <tr><td>Unknown:</td>                   <td><span class='cplate bgwhite'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Draft:</td>                     <td><span class='cplate bgred'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Informational:</td>             <td><span class='cplate bgorange'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Experimental:</td>              <td><span class='cplate bgyellow'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Best Common Practice:</td>      <td><span class='cplate bgmagenta'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Proposed Standard:</td>         <td><span class='cplate bgblue'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Draft Standard (old designation):</td> <td><span class='cplate bgcyan'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Internet Standard:</td>         <td><span class='cplate bggreen'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Historic:</td>                  <td><span class='cplate bggrey'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>         <tr><td>Obsolete:</td>                  <td><span class='cplate bgbrown'>&nbsp;&nbsp;&nbsp;&nbsp;</span></td></tr>     </table>";
    function showElem(id) {
        var elem = document.getElementById(id);
        elem.innerHTML = eval(id+"_html");
        elem.style.visibility='visible';
    }
    function hideElem(id) {
        var elem = document.getElementById(id);
        elem.style.visibility='hidden';        
        elem.innerHTML = "";
    }
    // -->
    </script>
</head>
<body onload="addHeaderTags()">
  <div class="content">
   <div style="height: 13px;">
      <div onmouseover="this.style.cursor='pointer';"
         onclick="showElem('legend');"
         onmouseout="hideElem('legend')"
	 style="height: 6px; position: absolute;"
         class="pre noprint docinfo bgblue"
         title="Click for colour legend." >                                                                        </div>
      <div id="legend"
           class="docinfo noprint pre legend"
           style="position:absolute; top: 4px; left: 4ex; visibility:hidden; background-color: white; padding: 4px 9px 5px 7px; border: solid #345 1px; "
           onmouseover="showElem('legend');"
           onmouseout="hideElem('legend');">
      </div>
   </div>
<span class="pre noprint docinfo top">[<a href="../html/" title="Document search and retrieval page">Docs</a>] [<a href="/rfc/rfc7622.txt" title="Plaintext version of this document">txt</a>|<a href="/pdf/rfc7622" title="PDF version of this document">pdf</a>] [<a href="./draft-ietf-xmpp-6122bis" title="draft-ietf-xmpp-6122bis">draft-ietf-xmpp-6...</a>] [<a href="/rfcdiff?difftype=--hwdiff&amp;url2=rfc7622" title="Inline diff (wdiff)">Diff1</a>] [<a href="/rfcdiff?url2=rfc7622" title="Side-by-side diff">Diff2</a>] [<a href="https://www.rfc-editor.org/errata_search.php?rfc=7622">Errata</a>]        </span><br />
<span class="pre noprint docinfo">                                                                        </span><br />
<span class="pre noprint docinfo">                                                       PROPOSED STANDARD</span><br />
<span class="pre noprint docinfo">                                                            <span style='color: #C00;'>Errata Exist</span></span><br />
<pre>
Internet Engineering Task Force (IETF)                    P. Saint-Andre
Request for Comments: 7622                                          &amp;yet
Obsoletes: <a href="./rfc6122">6122</a>                                           September 2015
Category: Standards Track
ISSN: 2070-1721


   <span class="h1">Extensible Messaging and Presence Protocol (XMPP): Address Format</span>

Abstract

   This document defines the address format for the Extensible Messaging
   and Presence Protocol (XMPP), including support for code points
   outside the ASCII range.  This document obsoletes <a href="./rfc6122">RFC 6122</a>.

Status of This Memo

   This is an Internet Standards Track document.

   This document is a product of the Internet Engineering Task Force
   (IETF).  It represents the consensus of the IETF community.  It has
   received public review and has been approved for publication by the
   Internet Engineering Steering Group (IESG).  Further information on
   Internet Standards is available in <a href="./rfc5741#section-2">Section&nbsp;2 of RFC 5741</a>.

   Information about the current status of this document, any errata,
   and how to provide feedback on it may be obtained at
   <a href="http://www.rfc-editor.org/info/rfc7622">http://www.rfc-editor.org/info/rfc7622</a>.

Copyright Notice

   Copyright (c) 2015 IETF Trust and the persons identified as the
   document authors.  All rights reserved.

   This document is subject to <a href="./bcp78">BCP 78</a> and the IETF Trust's Legal
   Provisions Relating to IETF Documents
   (<a href="http://trustee.ietf.org/license-info">http://trustee.ietf.org/license-info</a>) in effect on the date of
   publication of this document.  Please review these documents
   carefully, as they describe your rights and restrictions with respect
   to this document.  Code Components extracted from this document must
   include Simplified BSD License text as described in Section 4.e of
   the Trust Legal Provisions and are provided without warranty as
   described in the Simplified BSD License.








<span class="grey">Saint-Andre                  Standards Track                    [Page 1]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-2" id="page-2" href="#page-2" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


Table of Contents

   <a href="#section-1">1</a>. Introduction ....................................................<a href="#page-2">2</a>
   <a href="#section-2">2</a>. Terminology .....................................................<a href="#page-3">3</a>
   <a href="#section-3">3</a>. Addresses .......................................................<a href="#page-3">3</a>
      <a href="#section-3.1">3.1</a>. Fundamentals ...............................................<a href="#page-3">3</a>
      <a href="#section-3.2">3.2</a>. Domainpart .................................................<a href="#page-5">5</a>
      <a href="#section-3.3">3.3</a>. Localpart ..................................................<a href="#page-7">7</a>
      <a href="#section-3.4">3.4</a>. Resourcepart ...............................................<a href="#page-8">8</a>
      <a href="#section-3.5">3.5</a>. Examples ...................................................<a href="#page-9">9</a>
   <a href="#section-4">4</a>. Enforcement in JIDs and JID Parts ..............................<a href="#page-13">13</a>
   <a href="#section-5">5</a>. Internationalization Considerations ............................<a href="#page-15">15</a>
   <a href="#section-6">6</a>. IANA Considerations ............................................<a href="#page-16">16</a>
      <a href="#section-6.1">6.1</a>. Stringprep Profiles Registry ..............................<a href="#page-16">16</a>
   <a href="#section-7">7</a>. Security Considerations ........................................<a href="#page-16">16</a>
      <a href="#section-7.1">7.1</a>. Reuse of PRECIS ...........................................<a href="#page-16">16</a>
      <a href="#section-7.2">7.2</a>. Reuse of Unicode ..........................................<a href="#page-16">16</a>
      <a href="#section-7.3">7.3</a>. Address Spoofing ..........................................<a href="#page-16">16</a>
   <a href="#section-8">8</a>. Conformance Requirements .......................................<a href="#page-19">19</a>
   <a href="#section-9">9</a>. References .....................................................<a href="#page-21">21</a>
      <a href="#section-9.1">9.1</a>. Normative References ......................................<a href="#page-21">21</a>
      <a href="#section-9.2">9.2</a>. Informative References ....................................<a href="#page-22">22</a>
   <a href="#appendix-A">Appendix A</a>. Differences from <a href="./rfc6122">RFC 6122</a> .............................<a href="#page-26">26</a>
   Acknowledgements ..................................................<a href="#page-27">27</a>
   Author's Address ..................................................<a href="#page-27">27</a>

<span class="h2"><a class="selflink" name="section-1" href="#section-1">1</a>.  Introduction</span>

   The Extensible Messaging and Presence Protocol (XMPP) [<a href="./rfc6120" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC6120</a>] is an
   application profile of the Extensible Markup Language [<a href="#ref-XML" title="&quot;Extensible Markup Language (XML) 1.0 (Fifth Edition)&quot;">XML</a>] for
   streaming XML data in close to real time between any two or more
   network-aware entities.  The address format for XMPP entities was
   originally developed in the Jabber open-source community in 1999,
   first described by [<a href="#ref-XEP-0029" title="&quot;Definition of Jabber Identifiers (JIDs)&quot;">XEP-0029</a>] in 2002, and then defined canonically
   by [<a href="./rfc3920" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC3920</a>] in 2004 and [<a href="./rfc6122" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Address Format&quot;">RFC6122</a>] in 2011.

   As specified in RFCs 3920 and 6122, the XMPP address format used the
   "stringprep" technology for preparation and comparison of non-ASCII
   characters [<a href="./rfc3454" title="&quot;Preparation of Internationalized Strings (&quot;">RFC3454</a>].  Following the movement of internationalized
   domain names away from stringprep, this document defines the XMPP
   address format in a way that no longer depends on stringprep (see the
   Preparation, Enforcement, and Comparison of Internationalized Strings
   (PRECIS) problem statement [<a href="./rfc6885" title="&quot;Stringprep Revision and Problem Statement for the Preparation and Comparison of Internationalized Strings (PRECIS)&quot;">RFC6885</a>]).  Instead, this document builds
   upon the internationalization framework defined by the IETF's PRECIS
   working group [<a href="./rfc7564" title="&quot;PRECIS Framework: Preparation, Enforcement, and Comparison of Internationalized Strings in Application Protocols&quot;">RFC7564</a>].






<span class="grey">Saint-Andre                  Standards Track                    [Page 2]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-3" id="page-3" href="#page-3" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


   Although every attempt has been made to ensure that the characters
   allowed in Jabber Identifiers (JIDs) under stringprep are still
   allowed and handled in the same way under PRECIS, there is no
   guarantee of strict backward compatibility because of changes in
   Unicode and the fact that PRECIS handling is based on Unicode
   properties, not a hardcoded table of characters.  Because it is
   possible that previously valid JIDs might no longer be valid (or
   previously invalid JIDs might now be valid), operators of XMPP
   services are advised to perform careful testing before migrating
   accounts and other data (see <a href="./rfc7613#section-6">Section&nbsp;6 of [RFC7613]</a> for guidance).

   This document obsoletes <a href="./rfc6122">RFC 6122</a>.

<span class="h2"><a class="selflink" name="section-2" href="#section-2">2</a>.  Terminology</span>

   Many important terms used in this document are defined in [<a href="./rfc7564" title="&quot;PRECIS Framework: Preparation, Enforcement, and Comparison of Internationalized Strings in Application Protocols&quot;">RFC7564</a>],
   [<a href="./rfc5890" title="&quot;Internationalized Domain Names for Applications (IDNA): Definitions and Document Framework&quot;">RFC5890</a>], [<a href="./rfc6120" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC6120</a>], [<a href="./rfc6365" title="&quot;Terminology Used in Internationalization in the IETF&quot;">RFC6365</a>], and [<a href="#ref-Unicode" title="&quot;The Unicode Standard&quot;">Unicode</a>].

   The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
   "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and
   "OPTIONAL" in this document are to be interpreted as described in
   [<a href="./rfc2119" title="&quot;Key words for use in RFCs to Indicate Requirement Levels&quot;">RFC2119</a>].

<span class="h2"><a class="selflink" name="section-3" href="#section-3">3</a>.  Addresses</span>

<span class="h3"><a class="selflink" name="section-3.1" href="#section-3.1">3.1</a>.  Fundamentals</span>

   An XMPP entity is anything that can communicate using XMPP.  For
   historical reasons, the network address of an XMPP entity is called a
   JID.  A valid JID is a string of Unicode code points [<a href="#ref-Unicode" title="&quot;The Unicode Standard&quot;">Unicode</a>],
   encoded using UTF-8 [<a href="./rfc3629" title="&quot;UTF-8, a transformation format of ISO 10646&quot;">RFC3629</a>], and structured as an ordered sequence
   of localpart, domainpart, and resourcepart, where the first two parts
   are demarcated by the '@' character used as a separator and the last
   two parts are similarly demarcated by the '/' character (e.g.,
   &lt;juliet@example.com/balcony&gt;).

   The syntax for a JID is defined as follows, using the Augmented
   Backus-Naur Form (ABNF) as specified in [<a href="./rfc5234" title="&quot;Augmented BNF for Syntax Specifications: ABNF&quot;">RFC5234</a>].













<span class="grey">Saint-Andre                  Standards Track                    [Page 3]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-4" id="page-4" href="#page-4" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


      jid          = [ localpart "@" ] domainpart [ "/" resourcepart ]
      localpart    = 1*1023(userbyte)
                     ;
                     ; a "userbyte" is a byte used to represent a
                     ; UTF-8 encoded Unicode code point that can be
                     ; contained in a string that conforms to the
                     ; UsernameCaseMapped profile of the PRECIS
                     ; IdentifierClass defined in <a href="./rfc7613">RFC 7613</a>
                     ;
      domainpart   = IP-literal / IPv4address / ifqdn
                     ;
                     ; the "IPv4address" and "IP-literal" rules are
                     ; defined in RFCs 3986 and 6874, respectively,
                     ; and the first-match-wins (a.k.a. "greedy")
                     ; algorithm described in <a href="./rfc3986#appendix-B">Appendix&nbsp;B of RFC 3986</a>
                     ; applies to the matching process
                     ;
      ifqdn        = 1*1023(domainbyte)
                     ;
                     ; a "domainbyte" is a byte used to represent a
                     ; UTF-8 encoded Unicode code point that can be
                     ; contained in a string that conforms to <a href="./rfc5890">RFC 5890</a>
                     ;
      resourcepart = 1*1023(opaquebyte)
                     ;
                     ; an "opaquebyte" is a byte used to represent a
                     ; UTF-8 encoded Unicode code point that can be
                     ; contained in a string that conforms to the
                     ; OpaqueString profile of the PRECIS
                     ; FreeformClass defined in <a href="./rfc7613">RFC 7613</a>
                     ;

   All JIDs are based on the foregoing structure.  However, note that
   the formal syntax provided above does not capture all of the rules
   and restrictions that apply to JIDs, which are described below.

   Each allowable portion of a JID (localpart, domainpart, and
   resourcepart) is 1 to 1023 octets in length, resulting in a maximum
   total size (including the '@' and '/' separators) of 3071 octets.

      Implementation Note: The length limits on JIDs and parts of JIDs
      are based on octets (bytes), not characters.  UTF-8 encoding can
      result in more than one octet per character.

      Implementation Note: When dividing a JID into its component parts,
      an implementation needs to match the separator characters '@' and
      '/' before applying any transformation algorithms, which might
      decompose certain Unicode code points to the separator characters.



<span class="grey">Saint-Andre                  Standards Track                    [Page 4]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-5" id="page-5" href="#page-5" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


      Implementation Note: Reuse of the IP-literal rule from [<a href="./rfc6874" title="&quot;Representing IPv6 Zone Identifiers in Address Literals and Uniform Resource Identifiers&quot;">RFC6874</a>]
      implies that IPv6 addresses are enclosed within square brackets
      (i.e., beginning with '[' and ending with ']'), which was not the
      case with the definition of the XMPP address format in [<a href="./rfc3920" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC3920</a>]
      but which was changed in [<a href="./rfc6122" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Address Format&quot;">RFC6122</a>].  Also note that the IP-literal
      rule was updated between [<a href="./rfc3986" title="&quot;Uniform Resource Identifier (URI): Generic Syntax&quot;">RFC3986</a>] and [<a href="./rfc6874" title="&quot;Representing IPv6 Zone Identifiers in Address Literals and Uniform Resource Identifiers&quot;">RFC6874</a>] to optionally add
      a zone identifier to any literal address.

   This document defines the native format for JIDs; see [<a href="./rfc5122" title="&quot;Internationalized Resource Identifiers (IRIs) and Uniform Resource Identifiers (URIs) for the Extensible Messaging and Presence Protocol (XMPP)&quot;">RFC5122</a>] for
   information about the representation of a JID as a Uniform Resource
   Identifier (URI) [<a href="./rfc3986" title="&quot;Uniform Resource Identifier (URI): Generic Syntax&quot;">RFC3986</a>] or Internationalized Resource Identifier
   (IRI) [<a href="./rfc3987" title="&quot;Internationalized Resource Identifiers (IRIs)&quot;">RFC3987</a>] and the extraction of a JID from an XMPP URI or IRI.

<span class="h3"><a class="selflink" name="section-3.2" href="#section-3.2">3.2</a>.  Domainpart</span>

   The domainpart of a JID is the portion that remains once the
   following parsing steps are taken:

   1.  Remove any portion from the first '/' character to the end of the
       string (if there is a '/' character present).

   2.  Remove any portion from the beginning of the string to the first
       '@' character (if there is an '@' character present).

   This parsing order is important, as illustrated by example 15 in
   <a href="#section-3.5">Section 3.5</a>.

   The domainpart is the primary identifier and is the only REQUIRED
   element of a JID (a mere domainpart is a valid JID).  Typically,
   a domainpart identifies the "home" server to which clients connect
   for XML routing and data management functionality.  However, it is
   not necessary for an XMPP domainpart to identify an entity that
   provides core XMPP server functionality (e.g., a domainpart can
   identify an entity such as a multi-user chat service [<a href="#ref-XEP-0045" title="&quot;Multi-User Chat&quot;">XEP-0045</a>], a
   publish-subscribe service [<a href="#ref-XEP-0060" title="&quot;Publish-Subscribe&quot;">XEP-0060</a>], or a user directory).

   The domainpart for every XMPP service MUST be a fully qualified
   domain name (FQDN), an IPv4 address, an IPv6 address, or an
   unqualified hostname (i.e., a text label that is resolvable on a
   local network).

      Informational Note: The term "fully qualified domain name" is not
      well defined.  In [<a href="./rfc1034" title="&quot;Domain names - concepts and facilities&quot;">RFC1034</a>], it is also called an absolute domain
      name, and the two terms are associated in [<a href="./rfc1535" title="&quot;A Security Problem and Proposed Correction With Widely Deployed DNS Software&quot;">RFC1535</a>].  The earliest
      use of the term can be found in [<a href="./rfc1123" title="&quot;Requirements for Internet Hosts - Application and Support&quot;">RFC1123</a>].  References to those
      older specifications ought not to be construed as limiting the





<span class="grey">Saint-Andre                  Standards Track                    [Page 5]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-6" id="page-6" href="#page-6" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


      characters of a fully qualified domain name to the ASCII range;
      for example, [<a href="./rfc5890" title="&quot;Internationalized Domain Names for Applications (IDNA): Definitions and Document Framework&quot;">RFC5890</a>] mentions that a fully qualified domain name
      can contain one or more U-labels.

      Interoperability Note: Domainparts that are IP addresses might not
      be accepted by other services for the purpose of server-to-server
      communication, and domainparts that are unqualified hostnames
      cannot be used on public networks because they are resolvable only
      on a local network.

   If the domainpart includes a final character considered to be a label
   separator (dot) by [<a href="./rfc1034" title="&quot;Domain names - concepts and facilities&quot;">RFC1034</a>], this character MUST be stripped from
   the domainpart before the JID of which it is a part is used for the
   purpose of routing an XML stanza, comparing against another JID, or
   constructing an XMPP URI or IRI [<a href="./rfc5122" title="&quot;Internationalized Resource Identifiers (IRIs) and Uniform Resource Identifiers (URIs) for the Extensible Messaging and Presence Protocol (XMPP)&quot;">RFC5122</a>].  In particular, such a
   character MUST be stripped before any other canonicalization steps
   are taken.

   In general, the content of a domainpart is an Internationalized
   Domain Name (IDN) as described in the specifications for
   Internationalized Domain Names in Applications (commonly called
   "IDNA2008"), and a domainpart is an "IDNA-aware domain name slot" as
   defined in [<a href="./rfc5890" title="&quot;Internationalized Domain Names for Applications (IDNA): Definitions and Document Framework&quot;">RFC5890</a>].

   After any and all normalization, conversion, and mapping of code
   points as well as encoding of the string as UTF-8, a domainpart MUST
   NOT be zero octets in length and MUST NOT be more than 1023 octets in
   length.  (Naturally, the length limits of [<a href="./rfc1034" title="&quot;Domain names - concepts and facilities&quot;">RFC1034</a>] apply, and
   nothing in this document is to be interpreted as overriding those
   more fundamental limits.)

   Detailed rules and considerations for preparation, enforcement, and
   comparison are provided in the following sections.

<span class="h4"><a class="selflink" name="section-3.2.1" href="#section-3.2.1">3.2.1</a>.  Preparation</span>

   An entity that prepares a string for inclusion in an XMPP domainpart
   slot MUST ensure that the string consists only of Unicode code points
   that are allowed in NR-LDH labels or U-labels as defined in
   [<a href="./rfc5890" title="&quot;Internationalized Domain Names for Applications (IDNA): Definitions and Document Framework&quot;">RFC5890</a>].  This implies that the string MUST NOT include A-labels as
   defined in [<a href="./rfc5890" title="&quot;Internationalized Domain Names for Applications (IDNA): Definitions and Document Framework&quot;">RFC5890</a>]; each A-label MUST be converted to a U-label
   during preparation of a string for inclusion in a domainpart slot.
   In addition, the string MUST be encoded as UTF-8 [<a href="./rfc3629" title="&quot;UTF-8, a transformation format of ISO 10646&quot;">RFC3629</a>].








<span class="grey">Saint-Andre                  Standards Track                    [Page 6]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-7" id="page-7" href="#page-7" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


<span class="h4"><a class="selflink" name="section-3.2.2" href="#section-3.2.2">3.2.2</a>.  Enforcement</span>

   An entity that performs enforcement in XMPP domainpart slots MUST
   prepare a string as described in <a href="#section-3.2.1">Section 3.2.1</a> and MUST also apply
   the normalization, case-mapping, and width-mapping rules defined in
   [<a href="./rfc5892" title="&quot;The Unicode Code Points and Internationalized Domain Names for Applications (IDNA)&quot;">RFC5892</a>].

      Informational Note: The order in which the rules are applied for
      IDNA2008 (see [<a href="./rfc5892" title="&quot;The Unicode Code Points and Internationalized Domain Names for Applications (IDNA)&quot;">RFC5892</a>] and [<a href="./rfc5895" title="&quot;Mapping Characters for Internationalized Domain Names in Applications (IDNA) 2008&quot;">RFC5895</a>]) is different from the order
      for localparts and resourceparts as described under Sections <a href="#section-3.3">3.3</a>
      and 3.4.

<span class="h4"><a class="selflink" name="section-3.2.3" href="#section-3.2.3">3.2.3</a>.  Comparison</span>

   An entity that performs comparison of two strings before or after
   their inclusion in XMPP domainpart slots MUST prepare each string as
   specified in <a href="#section-3.2.1">Section 3.2.1</a> and then enforce the normalization,
   case-mapping, and width-mapping rules specified in <a href="#section-3.2.2">Section 3.2.2</a>.
   The two strings are to be considered equivalent if they are an exact
   octet-for-octet match (sometimes called "bit-string identity").

<span class="h3"><a class="selflink" name="section-3.3" href="#section-3.3">3.3</a>.  Localpart</span>

   The localpart of a JID is an optional identifier placed before the
   domainpart and separated from the latter by the '@' character.
   Typically, a localpart uniquely identifies the entity requesting and
   using network access provided by a server (i.e., a local account),
   although it can also represent other kinds of entities (e.g., a
   chatroom associated with a multi-user chat service [<a href="#ref-XEP-0045" title="&quot;Multi-User Chat&quot;">XEP-0045</a>]).  The
   entity represented by an XMPP localpart is addressed within the
   context of a specific domain (i.e., &lt;localpart@domainpart&gt;).

   The localpart of a JID MUST NOT be zero octets in length and MUST NOT
   be more than 1023 octets in length.  This rule is to be enforced
   after any normalization and mapping of code points as well as
   encoding of the string as UTF-8.

   The localpart of a JID is an instance of the UsernameCaseMapped
   profile of the PRECIS IdentifierClass, which is specified in
   [<a href="./rfc7613" title="&quot;Preparation, Enforcement, and Comparison of Internationalized Strings Representing Usernames and Passwords&quot;">RFC7613</a>].  The rules and considerations provided in that
   specification MUST be applied to XMPP localparts.

      Implementation Note: XMPP uses the Simple Authentication and
      Security Layer (SASL) [<a href="./rfc4422" title="&quot;Simple Authentication and Security Layer (SASL)&quot;">RFC4422</a>] for authentication.  At the time
      of this writing, some SASL mechanisms use SASLprep [<a href="./rfc4013" title="&quot;SASLprep: Stringprep Profile for User Names and Passwords&quot;">RFC4013</a>] for
      the handling of usernames and passwords; in the future, these SASL
      mechanisms will likely transition to the use of PRECIS-based
      handling rules as specified in [<a href="./rfc7613" title="&quot;Preparation, Enforcement, and Comparison of Internationalized Strings Representing Usernames and Passwords&quot;">RFC7613</a>].  For a detailed



<span class="grey">Saint-Andre                  Standards Track                    [Page 7]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-8" id="page-8" href="#page-8" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


      discussion about the implications of that transition (including
      the potential need to modify or remove certain characters in the
      underlying account database), see both <a href="#section-6">Section 6</a> and <a href="./rfc7613#appendix-A">Appendix&nbsp;A
      of [RFC7613]</a>.

<span class="h4"><a class="selflink" name="section-3.3.1" href="#section-3.3.1">3.3.1</a>.  Further Excluded Characters</span>

   In XMPP, the following characters are explicitly disallowed in XMPP
   localparts, even though they are allowed by the IdentifierClass base
   class and the UsernameCaseMapped profile:

      " U+0022 (QUOTATION MARK)

      &amp; U+0026 (AMPERSAND)

      ' U+0027 (APOSTROPHE)

      / U+002F (SOLIDUS)

      : U+003A (COLON)

      &lt; U+003C (LESS-THAN SIGN)

      &gt; U+003E (GREATER-THAN SIGN)

      @ U+0040 (COMMERCIAL AT)

      Implementation Note: An XMPP-specific method for escaping the
      foregoing characters (along with U+0020, i.e., ASCII space) has
      been defined in the JID Escaping specification [<a href="#ref-XEP-0106" title="&quot;JID Escaping&quot;">XEP-0106</a>].

<span class="h3"><a class="selflink" name="section-3.4" href="#section-3.4">3.4</a>.  Resourcepart</span>

   The resourcepart of a JID is an optional identifier placed after the
   domainpart and separated from the latter by the '/' character.  A
   resourcepart can modify either a &lt;localpart@domainpart&gt; address or a
   mere &lt;domainpart&gt; address.  Typically, a resourcepart uniquely
   identifies a specific connection (e.g., a device or location) or
   object (e.g., an occupant in a multi-user chatroom [<a href="#ref-XEP-0045" title="&quot;Multi-User Chat&quot;">XEP-0045</a>])
   belonging to the entity associated with an XMPP localpart at a domain
   (i.e., &lt;localpart@domainpart/resourcepart&gt;).










<span class="grey">Saint-Andre                  Standards Track                    [Page 8]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-9" id="page-9" href="#page-9" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


   XMPP entities SHOULD consider resourceparts to be opaque strings and
   SHOULD NOT impute meaning to any given resourcepart.  In particular:

   o  Use of the '/' character as a separator between the domainpart and
      the resourcepart does not imply that XMPP addresses are
      hierarchical in the way that, say, HTTP URIs are hierarchical (see
      [<a href="./rfc3986" title="&quot;Uniform Resource Identifier (URI): Generic Syntax&quot;">RFC3986</a>] for general discussion); thus, for example, an XMPP
      address of the form &lt;localpart@domainpart/foo/bar&gt; does not
      identify a resource "bar" that exists below a resource "foo" in a
      hierarchy of resources associated with the entity
      "localpart@domainpart".

   o  The '@' character is allowed in the resourcepart and is often used
      in the "handle" shown in XMPP chatrooms [<a href="#ref-XEP-0045" title="&quot;Multi-User Chat&quot;">XEP-0045</a>].  For example,
      the JID &lt;room@chat.example.com/user@host&gt; describes an entity who
      is an occupant of the room &lt;room@chat.example.com&gt; with a handle
      of &lt;user@host&gt;.  However, chatroom services do not necessarily
      check such an asserted handle against the occupant's real JID.

   The resourcepart of a JID MUST NOT be zero octets in length and MUST
   NOT be more than 1023 octets in length.  This rule is to be enforced
   after any normalization and mapping of code points as well as
   encoding of the string as UTF-8.

   The resourcepart of a JID is an instance of the OpaqueString profile
   of the PRECIS FreeformClass, which is specified in [<a href="./rfc7613" title="&quot;Preparation, Enforcement, and Comparison of Internationalized Strings Representing Usernames and Passwords&quot;">RFC7613</a>].  The
   rules and considerations provided in that specification MUST be
   applied to XMPP resourceparts.

<span class="h4"><a class="selflink" name="section-3.4.1" href="#section-3.4.1">3.4.1</a>.  Applicability to XMPP Extensions</span>

   In some contexts, it might be appropriate to apply more restrictive
   rules to the preparation, enforcement, and comparison of XMPP
   resourceparts.  For example, in XMPP Multi-User Chat [<a href="#ref-XEP-0045" title="&quot;Multi-User Chat&quot;">XEP-0045</a>] it
   might be appropriate to apply the rules specified in
   [<a href="#ref-PRECIS-Nickname">PRECIS-Nickname</a>].  However, the application of more restrictive
   rules is out of scope for resourceparts in general and is properly
   defined in specifications for the relevant XMPP extensions.

<span class="h3"><a class="selflink" name="section-3.5" href="#section-3.5">3.5</a>.  Examples</span>

   The following examples illustrate a small number of JIDs that are
   consistent with the format defined above (note that the characters
   "&lt;" and "&gt;" are used to delineate the actual JIDs and are not part of
   the JIDs themselves).






<span class="grey">Saint-Andre                  Standards Track                    [Page 9]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-10" id="page-10" href="#page-10" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


   +----------------------------------+-------------------------------+
   | # | JID                          | Notes                         |
   +----------------------------------+-------------------------------+
   | 1 | &lt;juliet@example.com&gt;         | A "bare JID"                  |
   +----------------------------------+-------------------------------+
   | 2 | &lt;juliet@example.com/foo&gt;     | A "full JID"                  |
   +----------------------------------+-------------------------------+
   | 3 | &lt;juliet@example.com/foo bar&gt; | Single space in resourcepart  |
   +----------------------------------+-------------------------------+
   | 4 | &lt;juliet@example.com/foo@bar&gt; | "At" sign in resourcepart     |
   +----------------------------------+-------------------------------+
   | 5 | &lt;foo\20bar@example.com&gt;      | Single space in localpart, as |
   |   |                              | optionally escaped using the  |
   |   |                              | XMPP JID Escaping extension   |
   +----------------------------------+-------------------------------+
   | 6 | &lt;fussball@example.com&gt;       | Another bare JID              |
   +----------------------------------+-------------------------------+
   | 7 | &lt;fu&amp;#xDF;ball@example.com&gt;   | The third character is LATIN  |
   |   |                              | SMALL LETTER SHARP S (U+00DF) |
   +----------------------------------+-------------------------------+
   | 8 | &lt;&amp;#x3C0;@example.com&gt;        | A localpart of GREEK SMALL    |
   |   |                              | LETTER PI (U+03C0)            |
   +----------------------------------+-------------------------------+
   | 9 | &lt;&amp;#x3A3;@example.com/foo&gt;    | A localpart of GREEK CAPITAL  |
   |   |                              | LETTER SIGMA (U+03A3)         |
   +----------------------------------+-------------------------------+
   | 10| &lt;&amp;#x3C3;@example.com/foo&gt;    | A localpart of GREEK SMALL    |
   |   |                              | LETTER SIGMA (U+03C3)         |
   +----------------------------------+-------------------------------+
   | 11| &lt;&amp;#x3C2;@example.com/foo&gt;    | A localpart of GREEK SMALL    |
   |   |                              | LETTER FINAL SIGMA (U+03C2)   |
   +----------------------------------+-------------------------------+
   | 12| &lt;king@example.com/&amp;#x265A&gt;;  | A resourcepart of the Unicode |
   |   |                              | character BLACK CHESS KING    |
   |   |                              | (U+265A)                      |
   +----------------------------------+-------------------------------+
   | 13| &lt;example.com&gt;                | A domainpart                  |
   +----------------------------------+-------------------------------+
   | 14| &lt;example.com/foobar&gt;         | A domainpart and resourcepart |
   +----------------------------------+-------------------------------+
   | 15| &lt;a.example.com/b@example.net&gt;| A domainpart followed by a    |
   |   |                              | resourcepart that contains an |
   |   |                              | "at" sign                     |
   +----------------------------------+-------------------------------+

                      Table 1: A Sample of Legal JIDs





<span class="grey">Saint-Andre                  Standards Track                   [Page 10]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-11" id="page-11" href="#page-11" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


   Several points are worth noting.  Regarding examples 6 and 7:
   although in German the character esszett (LATIN SMALL LETTER SHARP S
   (U+00DF)) can mostly be used interchangeably with the two characters
   "ss", the localparts in these examples are different, and (if
   desired) a server would need to enforce a registration policy that
   disallows one of them if the other is registered.  Regarding examples
   9, 10, and 11: case-mapping of GREEK CAPITAL LETTER SIGMA (U+03A3) to
   lowercase (i.e., to GREEK SMALL LETTER SIGMA (U+03C3)) during
   comparison would result in matching the JIDs in examples 9 and 10;
   however, because the PRECIS mapping rules do not account for the
   special status of GREEK SMALL LETTER FINAL SIGMA (U+03C2), the JIDs
   in examples 9 and 11 or examples 10 and 11 would not be matched.
   Regarding example 12: symbol characters such as BLACK CHESS KING
   (U+265A) are allowed by the PRECIS FreeformClass and thus can be used
   in resourceparts.  Regarding examples 14 and 15: JIDs consisting of a
   domainpart and resourcepart are rarely seen in the wild but are
   allowed according to the XMPP address format.  Example 15 illustrates
   the need for careful extraction of the domainpart as described in
   <a href="#section-3.2">Section 3.2</a>.
































<span class="grey">Saint-Andre                  Standards Track                   [Page 11]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-12" id="page-12" href="#page-12" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


   The following examples illustrate strings that are not JIDs because
   they violate the format defined above.

   +----------------------------------+-------------------------------+
   | # | Non-JID string               | Notes                         |
   +----------------------------------+-------------------------------+
   | 16| &lt;"juliet"@example.com&gt;       | Quotation marks (U+0022) in   |
   |   |                              | localpart                     |
   +----------------------------------+-------------------------------+
   | 17| &lt;foo bar@example.com&gt;        | Space (U+0020) in localpart   |
   +----------------------------------+-------------------------------+
   | 18| &lt;juliet@example.com/ foo&gt;    | Leading space in resourcepart |
   +----------------------------------+-------------------------------+
   | 19| &lt;@example.com/&gt;              | Zero-length localpart and     |
   |   |                              | resourcepart                  |
   +----------------------------------+-------------------------------+
   | 20| &lt;henry&amp;#x2163;@example.com&gt;  | The sixth character is ROMAN  |
   |   |                              | NUMERAL FOUR (U+2163)         |
   +----------------------------------+-------------------------------+
   | 21| &lt;&amp;#x265A;@example.com&gt;       | A localpart of BLACK CHESS    |
   |   |                              | KING (U+265A)                 |
   +----------------------------------+-------------------------------+
   | 22| &lt;juliet@&gt;                    | A localpart without a         |
   |   |                              | domainpart                    |
   +----------------------------------+-------------------------------+
   | 23| &lt;/foobar&gt;                    | A resourcepart without a      |
   |   |                              | domainpart                    |
   +----------------------------------+-------------------------------+

          Table 2: A Sample of Strings That Violate the JID Rules

   Here again, several points are worth noting.  Regarding example 17:
   even though ASCII space (U+0020) is disallowed in the PRECIS
   IdentifierClass, it can be escaped to "\20" in XMPP localparts by
   using the JID Escaping rules defined in [<a href="#ref-XEP-0106" title="&quot;JID Escaping&quot;">XEP-0106</a>], as illustrated by
   example 5 in Table 1.  Regarding example 20: the Unicode character
   ROMAN NUMERAL FOUR (U+2163) has a compatibility equivalent of the
   string formed of LATIN CAPITAL LETTER I (U+0049) and LATIN CAPITAL
   LETTER V (U+0056), but characters with compatibility equivalents are
   not allowed in the PRECIS IdentifierClass.  Regarding example 21:
   symbol characters such as BLACK CHESS KING (U+265A) are not allowed
   in the PRECIS IdentifierClass; however, both of the non-ASCII
   characters in examples 20 and 21 are allowed in the PRECIS
   FreeformClass and therefore in the XMPP resourcepart (as illustrated
   for U+265A by example 12 in Table 1).  Regarding examples 22 and 23:
   the domainpart is required in a JID.





<span class="grey">Saint-Andre                  Standards Track                   [Page 12]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-13" id="page-13" href="#page-13" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


<span class="h2"><a class="selflink" name="section-4" href="#section-4">4</a>.  Enforcement in JIDs and JID Parts</span>

   Enforcement entails applying all of the rules specified in this
   document.  Enforcement of the XMPP address format rules is the
   responsibility of XMPP servers.  Although XMPP clients SHOULD prepare
   complete JIDs and parts of JIDs in accordance with this document
   before including them in protocol slots within XML streams, XMPP
   servers MUST enforce the rules wherever possible and reject stanzas
   and other XML elements that violate the rules (for stanzas, by
   returning a &lt;jid-malformed/&gt; error to the sender as described in
   <a href="./rfc6120#section-8.3.3.8">Section&nbsp;8.3.3.8 of [RFC6120]</a>).

   Entities that enforce the rules specified in this document are
   encouraged to be liberal in what they accept by following this
   procedure:

   1.  Where possible, map characters (e.g., through width mapping,
       additional mapping, special mapping, case mapping, or
       normalization) and accept the mapped string.

   2.  If mapping is not possible (e.g., because a character is
       disallowed in the FreeformClass), reject the string and return a
       &lt;jid-malformed/&gt; error.

   Enforcement applies to complete JIDs and to parts of JIDs.  To
   facilitate implementation, this document defines the concepts of "JID
   slot", "localpart slot", and "resourcepart slot" (similar to the
   concept of a "domain name slot" for IDNA2008 as defined in
   <a href="./rfc5890#section-2.3.2.6">Section&nbsp;2.3.2.6 of [RFC5890]</a>):

   JID Slot:  An XML element or attribute explicitly designated in XMPP
      or in XMPP extensions for carrying a complete JID.

   Localpart Slot:  An XML element or attribute explicitly designated
      in XMPP or in XMPP extensions for carrying the localpart of a JID.

   Resourcepart Slot:  An XML element or attribute explicitly designated
      in XMPP or in XMPP extensions for carrying the resourcepart of
      a JID.

   A server is responsible for enforcing the address format rules when
   receiving protocol elements from clients where the server is expected
   to handle such elements directly or to use them for purposes of
   routing a stanza to another domain or delivering a stanza to a local
   entity; two examples from [<a href="./rfc6120" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC6120</a>] are the 'to' attribute on XML
   stanzas (which is a JID slot used by XMPP servers for routing of
   outbound stanzas) and the &lt;resource/&gt; child of the &lt;bind/&gt; element
   (which is a resourcepart slot used by XMPP servers for binding of a



<span class="grey">Saint-Andre                  Standards Track                   [Page 13]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-14" id="page-14" href="#page-14" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


   resource to an account for routing of stanzas between the server and
   a particular client).  An example from [<a href="./rfc6121" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Instant Messaging and Presence&quot;">RFC6121</a>] is the 'jid'
   attribute of the roster &lt;item/&gt; element.

   A server is not responsible for enforcing the rules when the protocol
   elements are intended for communication among other entities,
   typically within the payload of a stanza that the server is merely
   routing to another domain or delivering to a local entity.  Two
   examples are the 'initiator' attribute in the Jingle extension
   [<a href="#ref-XEP-0166" title="&quot;Jingle&quot;">XEP-0166</a>] (which is a JID slot used for client-to-client
   coordination of multimedia sessions) and the 'nick' attribute in the
   Multi-User Chat extension [<a href="#ref-XEP-0045" title="&quot;Multi-User Chat&quot;">XEP-0045</a>] (which is a resourcepart slot
   used for administrative purposes in the context of XMPP chatrooms).
   In such cases, the entities involved SHOULD enforce the rules
   themselves and not depend on the server to do so, and client
   implementers need to understand that not enforcing the rules can lead
   to a degraded user experience or to security vulnerabilities.
   However, when an add-on service (e.g., a multi-user chat service)
   handles a stanza directly, it ought to enforce the rules as well, as
   defined in the relevant specification for that type of service.

   This document does not provide an exhaustive list of JID slots,
   localpart slots, or resourcepart slots.  However, implementers of
   core XMPP servers are advised to consider as JID slots at least the
   following elements and attributes when they are handled directly or
   used for purposes of routing to another domain or delivering to a
   local entity:

   o  The 'from' and 'to' stream attributes and the 'from' and 'to'
      stanza attributes [<a href="./rfc6120" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC6120</a>].

   o  The 'jid' attribute of the roster &lt;item/&gt; element for contact list
      management [<a href="./rfc6121" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Instant Messaging and Presence&quot;">RFC6121</a>].

   o  The 'value' attribute of the &lt;item/&gt; element for Privacy Lists
      [<a href="./rfc3921" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Instant Messaging and Presence&quot;">RFC3921</a>] [<a href="#ref-XEP-0016" title="&quot;Privacy Lists&quot;">XEP-0016</a>] when the value of the 'type' attribute
      is "jid".

   o  The 'jid' attribute of the &lt;item/&gt; element for Service Discovery
      defined in [<a href="#ref-XEP-0030" title="&quot;Service Discovery&quot;">XEP-0030</a>].

   o  The &lt;value/&gt; element for Data Forms [<a href="#ref-XEP-0004" title="&quot;Data Forms&quot;">XEP-0004</a>] when the 'type'
      attribute is "jid-single" or "jid-multi".

   o  The 'jid' attribute of the &lt;conference/&gt; element for Bookmark
      Storage [<a href="#ref-XEP-0048" title="&quot;Bookmarks&quot;">XEP-0048</a>].





<span class="grey">Saint-Andre                  Standards Track                   [Page 14]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-15" id="page-15" href="#page-15" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


   o  The &lt;JABBERID/&gt; of the &lt;vCard/&gt; element for vCard 3.0 [<a href="#ref-XEP-0054" title="&quot;vcard-temp&quot;">XEP-0054</a>]
      and the &lt;uri/&gt; child of the &lt;impp/&gt; element for vCard 4.0
      [<a href="#ref-XEP-0292" title="&quot;vCard4 Over XMPP&quot;">XEP-0292</a>] when the XML character data identifies an XMPP URI
      [<a href="./rfc5122" title="&quot;Internationalized Resource Identifiers (IRIs) and Uniform Resource Identifiers (URIs) for the Extensible Messaging and Presence Protocol (XMPP)&quot;">RFC5122</a>].

   o  The 'from' attribute of the &lt;delay/&gt; element for Delayed Delivery
      [<a href="#ref-XEP-0203" title="&quot;Delayed Delivery&quot;">XEP-0203</a>].

   o  The 'jid' attribute of the &lt;item/&gt; element for the Blocking
      Command [<a href="#ref-XEP-0191" title="&quot;Blocking Command&quot;">XEP-0191</a>].

   o  The 'from' and 'to' attributes of the &lt;result/&gt; and &lt;verify/&gt;
      elements for Server Dialback [<a href="#ref-XEP-0220" title="&quot;Server Dialback&quot;">XEP-0220</a>].

   o  The 'from' and 'to' attributes of the &lt;iq/&gt;, &lt;message/&gt;, and
      &lt;presence/&gt; elements for the Jabber Component Protocol [<a href="#ref-XEP-0114" title="&quot;Jabber Component Protocol&quot;">XEP-0114</a>].

   Developers of XMPP clients and specialized XMPP add-on services are
   advised to check the appropriate specifications for JID slots,
   localpart slots, and resourcepart slots in XMPP protocol extensions
   such as Service Discovery [<a href="#ref-XEP-0030" title="&quot;Service Discovery&quot;">XEP-0030</a>], Multi-User Chat [<a href="#ref-XEP-0045" title="&quot;Multi-User Chat&quot;">XEP-0045</a>],
   Publish-Subscribe [<a href="#ref-XEP-0060" title="&quot;Publish-Subscribe&quot;">XEP-0060</a>], SOCKS5 Bytestreams [<a href="#ref-XEP-0065" title="&quot;SOCKS5 Bytestreams&quot;">XEP-0065</a>], In-Band
   Registration [<a href="#ref-XEP-0077" title="&quot;In-Band Registration&quot;">XEP-0077</a>], Roster Item Exchange [<a href="#ref-XEP-0144" title="&quot;Roster Item Exchange&quot;">XEP-0144</a>], and Jingle
   [<a href="#ref-XEP-0166" title="&quot;Jingle&quot;">XEP-0166</a>].

<span class="h2"><a class="selflink" name="section-5" href="#section-5">5</a>.  Internationalization Considerations</span>

   XMPP applications MUST support IDNA2008 for domainparts as described
   under <a href="#section-3.2">Section 3.2</a>, the UsernameCaseMapped profile for localparts as
   described under <a href="#section-3.3">Section 3.3</a>, and the OpaqueString profile for
   resourceparts as described under <a href="#section-3.4">Section 3.4</a>.  This enables XMPP
   addresses to include a wide variety of characters outside the ASCII
   range.  Rules for enforcement of the XMPP address format are provided
   in [<a href="./rfc6120" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC6120</a>] and specifications for various XMPP extensions.

      Interoperability Note: For backward compatibility, many existing
      XMPP implementations and deployments support IDNA2003 [<a href="./rfc3490" title="&quot;Internationalizing Domain Names in Applications (IDNA)&quot;">RFC3490</a>]
      for domainparts, and the stringprep [<a href="./rfc3454" title="&quot;Preparation of Internationalized Strings (&quot;">RFC3454</a>] profiles Nodeprep
      and Resourceprep [<a href="./rfc3920" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC3920</a>] for localparts and resourceparts.












<span class="grey">Saint-Andre                  Standards Track                   [Page 15]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-16" id="page-16" href="#page-16" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


<span class="h2"><a class="selflink" name="section-6" href="#section-6">6</a>.  IANA Considerations</span>

<span class="h3"><a class="selflink" name="section-6.1" href="#section-6.1">6.1</a>.  Stringprep Profiles Registry</span>

   The stringprep specification [<a href="./rfc3454" title="&quot;Preparation of Internationalized Strings (&quot;">RFC3454</a>] did not provide for entries in
   the "Stringprep Profiles" registry to have any state except "Current"
   or "Not Current".  Because this document obsoletes <a href="./rfc6122">RFC 6122</a>, which
   registered the Nodeprep and Resourceprep profiles of stringprep, IANA
   has marked those profiles as "Not Current" and cited this document as
   an additional reference.

<span class="h2"><a class="selflink" name="section-7" href="#section-7">7</a>.  Security Considerations</span>

<span class="h3"><a class="selflink" name="section-7.1" href="#section-7.1">7.1</a>.  Reuse of PRECIS</span>

   The security considerations described in [<a href="./rfc7564" title="&quot;PRECIS Framework: Preparation, Enforcement, and Comparison of Internationalized Strings in Application Protocols&quot;">RFC7564</a>] apply to the
   IdentifierClass and FreeformClass base string classes used in this
   document for XMPP localparts and resourceparts, respectively.  The
   security considerations described in [<a href="./rfc5890" title="&quot;Internationalized Domain Names for Applications (IDNA): Definitions and Document Framework&quot;">RFC5890</a>] apply to
   internationalized domain names, which are used here for XMPP
   domainparts.

<span class="h3"><a class="selflink" name="section-7.2" href="#section-7.2">7.2</a>.  Reuse of Unicode</span>

   The security considerations described in [<a href="#ref-UTS39" title="&quot;Unicode Security Mechanisms&quot;">UTS39</a>] apply to the use of
   Unicode characters in XMPP addresses.

<span class="h3"><a class="selflink" name="section-7.3" href="#section-7.3">7.3</a>.  Address Spoofing</span>

   There are two forms of address spoofing: forging and mimicking.

<span class="h4"><a class="selflink" name="section-7.3.1" href="#section-7.3.1">7.3.1</a>.  Address Forging</span>

   In the context of XMPP technologies, address forging occurs when an
   entity is able to generate an XML stanza whose 'from' address does
   not correspond to the account credentials with which the entity
   authenticated onto the network (or an authorization identity provided
   during negotiation of SASL authentication [<a href="./rfc4422" title="&quot;Simple Authentication and Security Layer (SASL)&quot;">RFC4422</a>] as described in
   [<a href="./rfc6120" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC6120</a>]).  For example, address forging occurs if an entity that
   authenticated as "juliet@im.example.com" is able to send XML stanzas
   from "nurse@im.example.com" or "romeo@example.net".










<span class="grey">Saint-Andre                  Standards Track                   [Page 16]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-17" id="page-17" href="#page-17" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


   Address forging is difficult in XMPP systems, given the requirement
   for sending servers to stamp 'from' addresses and for receiving
   servers to verify sending domains via server-to-server authentication
   (see [<a href="./rfc6120" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC6120</a>]).  However, address forging is possible if:

   o  A poorly implemented server ignores the requirement for stamping
      the 'from' address.  This would enable any entity that
      authenticated with the server to send stanzas from any
      localpart@domainpart as long as the domainpart matches the sending
      domain of the server.

   o  An actively malicious server generates stanzas on behalf of any
      registered account at the domain or domains hosted at that server.

   Therefore, an entity outside the security perimeter of a particular
   server cannot reliably distinguish between JIDs of the form
   &lt;localpart@domainpart&gt; at that server and thus can authenticate only
   the domainpart of such JIDs with any level of assurance.  This
   specification does not define methods for discovering or
   counteracting the kind of poorly implemented or rogue servers just
   described.  However, the end-to-end authentication or signing of XMPP
   stanzas could help to mitigate this risk, because it would require
   the rogue server to generate false credentials for signing or
   encryption of each stanza, in addition to modifying 'from' addresses.

<span class="h4"><a class="selflink" name="section-7.3.2" href="#section-7.3.2">7.3.2</a>.  Address Mimicking</span>

   Address mimicking occurs when an entity provides legitimate
   authentication credentials for, and sends XML stanzas from, an
   account whose JID appears to a human user to be the same as another
   JID.  Because many characters are visually similar, it is relatively
   easy to mimic JIDs in XMPP systems.  As one simple example, the
   localpart "ju1iet" (using the Arabic numeral one as the third
   character) might appear the same as the localpart "juliet" (using
   lowercase "L" as the third character).

   As explained in [<a href="./rfc5890" title="&quot;Internationalized Domain Names for Applications (IDNA): Definitions and Document Framework&quot;">RFC5890</a>], [<a href="./rfc7564" title="&quot;PRECIS Framework: Preparation, Enforcement, and Comparison of Internationalized Strings in Application Protocols&quot;">RFC7564</a>], [<a href="#ref-UTR36" title="&quot;Unicode Security Considerations&quot;">UTR36</a>], and [<a href="#ref-UTS39" title="&quot;Unicode Security Mechanisms&quot;">UTS39</a>], there is
   no straightforward solution to the problem of visually similar
   characters.  Furthermore, IDNA and PRECIS technologies do not attempt
   to define such a solution.  As a result, XMPP domainparts,
   localparts, and resourceparts could contain such characters, leading
   to security vulnerabilities such as the following:

   o  A domainpart is always employed as one part of an entity's address
      in XMPP.  One common usage is as the address of a server or
      server-side service, such as a multi-user chat service [<a href="#ref-XEP-0045" title="&quot;Multi-User Chat&quot;">XEP-0045</a>].
      The security of such services could be compromised based on
      different interpretations of the internationalized domainpart; for



<span class="grey">Saint-Andre                  Standards Track                   [Page 17]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-18" id="page-18" href="#page-18" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


      example, a user might authorize a malicious entity at a fake
      server to view the user's presence information, or a user could
      join chatrooms at a fake multi-user chat service.

   o  A localpart can be employed as one part of an entity's address in
      XMPP.  One common usage is as the username of an instant messaging
      user; another is as the name of a multi-user chatroom; and many
      other kinds of entities could use localparts as part of their
      addresses.  The security of such services could be compromised
      based on different interpretations of the internationalized
      localpart; for example, a user entering a single internationalized
      localpart could access another user's account information, or a
      user could gain access to a hidden or otherwise restricted
      chatroom or service.

   o  A resourcepart can be employed as one part of an entity's address
      in XMPP.  One common usage is as the name for an instant messaging
      user's connected resource; another is as the nickname of a user in
      a multi-user chatroom; and many other kinds of entities could use
      resourceparts as part of their addresses.  The security of such
      services could be compromised based on different interpretations
      of the internationalized resourcepart; for example, two or more
      confusable resources could be bound at the same time to the same
      account (resulting in inconsistent authorization decisions in an
      XMPP application that uses full JIDs), or a user could send a
      private message to someone other than the intended recipient in a
      multi-user chatroom.

   XMPP services and clients are strongly encouraged to define and
   implement consistent policies regarding the registration, storage,
   and presentation of visually similar characters in XMPP systems.  In
   particular, service providers and software implementers are strongly
   encouraged to apply the policies recommended in [<a href="./rfc7564" title="&quot;PRECIS Framework: Preparation, Enforcement, and Comparison of Internationalized Strings in Application Protocols&quot;">RFC7564</a>].


















<span class="grey">Saint-Andre                  Standards Track                   [Page 18]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-19" id="page-19" href="#page-19" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


<span class="h2"><a class="selflink" name="section-8" href="#section-8">8</a>.  Conformance Requirements</span>

   This section describes a protocol feature set that summarizes the
   conformance requirements of this specification (similar feature sets
   are provided for XMPP in [<a href="./rfc6120" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Core&quot;">RFC6120</a>] and [<a href="./rfc6121" title="&quot;Extensible Messaging and Presence Protocol (XMPP): Instant Messaging and Presence&quot;">RFC6121</a>]).  The summary is
   purely informational, and the conformance keywords of [<a href="./rfc2119" title="&quot;Key words for use in RFCs to Indicate Requirement Levels&quot;">RFC2119</a>] as
   used here are intended only to briefly describe the referenced
   normative text from the body of this specification.  This feature set
   is appropriate for use in software certification, interoperability
   testing, and implementation reports.  For each feature, this section
   provides the following information:

   o  A human-readable name

   o  An informational description

   o  A reference to the particular section of this document that
      normatively defines the feature

   o  Whether the feature applies to the client role, the server role,
      or both (where "N/A" signifies that the feature is not applicable
      to the specified role)

   o  Whether the feature MUST or SHOULD be implemented, where the
      capitalized terms are to be understood as described in [<a href="./rfc2119" title="&quot;Key words for use in RFCs to Indicate Requirement Levels&quot;">RFC2119</a>]

   The feature set specified here provides a basis for interoperability
   testing and follows the spirit of a proposal made by Larry Masinter
   within the IETF's NEWTRK working group in 2005 [<a href="#ref-INTEROP" title="&quot;Formalizing IETF Interoperability Reporting&quot;">INTEROP</a>].

   Feature:  address-domain-length

   Description:  Ensure that the domainpart of an XMPP address is at
      least one octet in length and at most 1023 octets in length, and
      that it conforms to the underlying length limits of the DNS.

   Section:  <a href="#section-3.2">Section 3.2</a>

   Roles:  Server MUST, client SHOULD.












<span class="grey">Saint-Andre                  Standards Track                   [Page 19]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-20" id="page-20" href="#page-20" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


   Feature:  address-domain-prep

   Description:  Ensure that the domainpart of an XMPP address conforms
      to IDNA2008, that it contains only NR-LDH labels and U-labels (not
      A-labels), and that all uppercase and titlecase code points are
      mapped to their lowercase equivalents.

   Section:  <a href="#section-3.2">Section 3.2</a>

   Roles:  Server MUST, client SHOULD.


   Feature:  address-localpart-length

   Description:  Ensure that the localpart of an XMPP address is at
      least one octet in length and at most 1023 octets in length.

   Section:  <a href="#section-3.3">Section 3.3</a>

   Roles:  Server MUST, client SHOULD.


   Feature:  address-localpart-prep

   Description:  Ensure that the localpart of an XMPP address conforms
      to the UsernameCaseMapped profile of the PRECIS IdentifierClass.

   Section:  <a href="#section-3.3">Section 3.3</a>

   Roles:  Server MUST, client SHOULD.


   Feature:  address-resource-length

   Description:  Ensure that the resourcepart of an XMPP address is at
      least one octet in length and at most 1023 octets in length.

   Section:  <a href="#section-3.4">Section 3.4</a>

   Roles:  Server MUST, client SHOULD.











<span class="grey">Saint-Andre                  Standards Track                   [Page 20]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-21" id="page-21" href="#page-21" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


   Feature:  address-resource-prep

   Description:  Ensure that the resourcepart of an XMPP address
      conforms to the OpaqueString profile of the PRECIS FreeformClass.

   Section:  <a href="#section-3.4">Section 3.4</a>

   Roles:  Server MUST, client SHOULD.

<span class="h2"><a class="selflink" name="section-9" href="#section-9">9</a>.  References</span>

<span class="h3"><a class="selflink" name="section-9.1" href="#section-9.1">9.1</a>.  Normative References</span>

   [<a name="ref-RFC1034" id="ref-RFC1034">RFC1034</a>]  Mockapetris, P., "Domain names - concepts and facilities",
              STD 13, <a href="./rfc1034">RFC 1034</a>, DOI 10.17487/RFC1034, November 1987,
              &lt;<a href="http://www.rfc-editor.org/info/rfc1034">http://www.rfc-editor.org/info/rfc1034</a>&gt;.

   [<a name="ref-RFC2119" id="ref-RFC2119">RFC2119</a>]  Bradner, S., "Key words for use in RFCs to Indicate
              Requirement Levels", <a href="./bcp14">BCP 14</a>, <a href="./rfc2119">RFC 2119</a>,
              DOI 10.17487/RFC2119, March 1997,
              &lt;<a href="http://www.rfc-editor.org/info/rfc2119">http://www.rfc-editor.org/info/rfc2119</a>&gt;.

   [<a name="ref-RFC3629" id="ref-RFC3629">RFC3629</a>]  Yergeau, F., "UTF-8, a transformation format of
              ISO 10646", STD 63, <a href="./rfc3629">RFC 3629</a>, DOI 10.17487/RFC3629,
              November 2003, &lt;<a href="http://www.rfc-editor.org/info/rfc3629">http://www.rfc-editor.org/info/rfc3629</a>&gt;.

   [<a name="ref-RFC3986" id="ref-RFC3986">RFC3986</a>]  Berners-Lee, T., Fielding, R., and L. Masinter, "Uniform
              Resource Identifier (URI): Generic Syntax", STD 66,
              <a href="./rfc3986">RFC 3986</a>, DOI 10.17487/RFC3986, January 2005,
              &lt;<a href="http://www.rfc-editor.org/info/rfc3986">http://www.rfc-editor.org/info/rfc3986</a>&gt;.

   [<a name="ref-RFC5234" id="ref-RFC5234">RFC5234</a>]  Crocker, D., Ed., and P. Overell, "Augmented BNF for
              Syntax Specifications: ABNF", STD 68, <a href="./rfc5234">RFC 5234</a>,
              DOI 10.17487/RFC5234, January 2008,
              &lt;<a href="http://www.rfc-editor.org/info/rfc5234">http://www.rfc-editor.org/info/rfc5234</a>&gt;.

   [<a name="ref-RFC5890" id="ref-RFC5890">RFC5890</a>]  Klensin, J., "Internationalized Domain Names for
              Applications (IDNA): Definitions and Document Framework",
              <a href="./rfc5890">RFC 5890</a>, DOI 10.17487/RFC5890, August 2010,
              &lt;<a href="http://www.rfc-editor.org/info/rfc5890">http://www.rfc-editor.org/info/rfc5890</a>&gt;.

   [<a name="ref-RFC5892" id="ref-RFC5892">RFC5892</a>]  Faltstrom, P., Ed., "The Unicode Code Points and
              Internationalized Domain Names for Applications (IDNA)",
              <a href="./rfc5892">RFC 5892</a>, DOI 10.17487/RFC5892, August 2010,
              &lt;<a href="http://www.rfc-editor.org/info/rfc5892">http://www.rfc-editor.org/info/rfc5892</a>&gt;.






<span class="grey">Saint-Andre                  Standards Track                   [Page 21]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-22" id="page-22" href="#page-22" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


   [<a name="ref-RFC6120" id="ref-RFC6120">RFC6120</a>]  Saint-Andre, P., "Extensible Messaging and Presence
              Protocol (XMPP): Core", <a href="./rfc6120">RFC 6120</a>, DOI 10.17487/RFC6120,
              March 2011, &lt;<a href="http://www.rfc-editor.org/info/rfc6120">http://www.rfc-editor.org/info/rfc6120</a>&gt;.

   [<a name="ref-RFC6365" id="ref-RFC6365">RFC6365</a>]  Hoffman, P. and J. Klensin, "Terminology Used in
              Internationalization in the IETF", <a href="./bcp166">BCP 166</a>, <a href="./rfc6365">RFC 6365</a>,
              DOI 10.17487/RFC6365, September 2011,
              &lt;<a href="http://www.rfc-editor.org/info/rfc6365">http://www.rfc-editor.org/info/rfc6365</a>&gt;.

   [<a name="ref-RFC6874" id="ref-RFC6874">RFC6874</a>]  Carpenter, B., Cheshire, S., and R. Hinden, "Representing
              IPv6 Zone Identifiers in Address Literals and Uniform
              Resource Identifiers", <a href="./rfc6874">RFC 6874</a>, DOI 10.17487/RFC6874,
              February 2013, &lt;<a href="http://www.rfc-editor.org/info/rfc6874">http://www.rfc-editor.org/info/rfc6874</a>&gt;.

   [<a name="ref-RFC7564" id="ref-RFC7564">RFC7564</a>]  Saint-Andre, P. and M. Blanchet, "PRECIS Framework:
              Preparation, Enforcement, and Comparison of
              Internationalized Strings in Application Protocols",
              <a href="./rfc7564">RFC 7564</a>, DOI 10.17487/RFC7564, May 2015,
              &lt;<a href="http://www.rfc-editor.org/info/rfc7564">http://www.rfc-editor.org/info/rfc7564</a>&gt;.

   [<a name="ref-RFC7613" id="ref-RFC7613">RFC7613</a>]  Saint-Andre, P. and A. Melnikov, "Preparation,
              Enforcement, and Comparison of Internationalized Strings
              Representing Usernames and Passwords", <a href="./rfc7613">RFC 7613</a>,
              DOI 10.17487/RFC7613, August 2015,
              &lt;<a href="http://www.rfc-editor.org/info/rfc7613">http://www.rfc-editor.org/info/rfc7613</a>&gt;.

   [<a name="ref-Unicode" id="ref-Unicode">Unicode</a>]  The Unicode Consortium, "The Unicode Standard",
              &lt;<a href="http://www.unicode.org/versions/latest/">http://www.unicode.org/versions/latest/</a>&gt;.

   [<a name="ref-UTR36" id="ref-UTR36">UTR36</a>]    Unicode Technical Report #36, "Unicode Security
              Considerations", edited by Mark Davis and Michel Suignard,
              &lt;<a href="http://www.unicode.org/reports/tr36/">http://www.unicode.org/reports/tr36/</a>&gt;.

<span class="h3"><a class="selflink" name="section-9.2" href="#section-9.2">9.2</a>.  Informative References</span>

   [<a name="ref-INTEROP" id="ref-INTEROP">INTEROP</a>]  Masinter, L., "Formalizing IETF Interoperability
              Reporting", Work in Progress,
              <a href="./draft-ietf-newtrk-interop-reports-00">draft-ietf-newtrk-interop-reports-00</a>, October 2005.

   [<a name="ref-PRECIS-Nickname" id="ref-PRECIS-Nickname">PRECIS-Nickname</a>]
              Saint-Andre, P., "Preparation, Enforcement, and Comparison
              of Internationalized Strings Representing Nicknames", Work
              in Progress, <a href="./draft-ietf-precis-nickname-18">draft-ietf-precis-nickname-18</a>, June 2015.

   [<a name="ref-RFC1123" id="ref-RFC1123">RFC1123</a>]  Braden, R., Ed., "Requirements for Internet Hosts -
              Application and Support", STD 3, <a href="./rfc1123">RFC 1123</a>,
              DOI 10.17487/RFC1123, October 1989,
              &lt;<a href="http://www.rfc-editor.org/info/rfc1123">http://www.rfc-editor.org/info/rfc1123</a>&gt;.



<span class="grey">Saint-Andre                  Standards Track                   [Page 22]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-23" id="page-23" href="#page-23" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


   [<a name="ref-RFC1535" id="ref-RFC1535">RFC1535</a>]  Gavron, E., "A Security Problem and Proposed Correction
              With Widely Deployed DNS Software", <a href="./rfc1535">RFC 1535</a>,
              DOI 10.17487/RFC1535, October 1993,
              &lt;<a href="http://www.rfc-editor.org/info/rfc1535">http://www.rfc-editor.org/info/rfc1535</a>&gt;.

   [<a name="ref-RFC3454" id="ref-RFC3454">RFC3454</a>]  Hoffman, P. and M. Blanchet, "Preparation of
              Internationalized Strings ("stringprep")", <a href="./rfc3454">RFC 3454</a>,
              DOI 10.17487/RFC3454, December 2002,
              &lt;<a href="http://www.rfc-editor.org/info/rfc3454">http://www.rfc-editor.org/info/rfc3454</a>&gt;.

   [<a name="ref-RFC3490" id="ref-RFC3490">RFC3490</a>]  Faltstrom, P., Hoffman, P., and A. Costello,
              "Internationalizing Domain Names in Applications (IDNA)",
              <a href="./rfc3490">RFC 3490</a>, DOI 10.17487/RFC3490, March 2003,
              &lt;<a href="http://www.rfc-editor.org/info/rfc3490">http://www.rfc-editor.org/info/rfc3490</a>&gt;.

   [<a name="ref-RFC3920" id="ref-RFC3920">RFC3920</a>]  Saint-Andre, P., Ed., "Extensible Messaging and Presence
              Protocol (XMPP): Core", <a href="./rfc3920">RFC 3920</a>, DOI 10.17487/RFC3920,
              October 2004, &lt;<a href="http://www.rfc-editor.org/info/rfc3920">http://www.rfc-editor.org/info/rfc3920</a>&gt;.

   [<a name="ref-RFC3921" id="ref-RFC3921">RFC3921</a>]  Saint-Andre, P., Ed., "Extensible Messaging and Presence
              Protocol (XMPP): Instant Messaging and Presence",
              <a href="./rfc3921">RFC 3921</a>, DOI 10.17487/RFC3921, October 2004,
              &lt;<a href="http://www.rfc-editor.org/info/rfc3921">http://www.rfc-editor.org/info/rfc3921</a>&gt;.

   [<a name="ref-RFC3987" id="ref-RFC3987">RFC3987</a>]  Duerst, M. and M. Suignard, "Internationalized Resource
              Identifiers (IRIs)", <a href="./rfc3987">RFC 3987</a>, DOI 10.17487/RFC3987,
              January 2005, &lt;<a href="http://www.rfc-editor.org/info/rfc3987">http://www.rfc-editor.org/info/rfc3987</a>&gt;.

   [<a name="ref-RFC4013" id="ref-RFC4013">RFC4013</a>]  Zeilenga, K., "SASLprep: Stringprep Profile for User Names
              and Passwords", <a href="./rfc4013">RFC 4013</a>, DOI 10.17487/RFC4013,
              February 2005, &lt;<a href="http://www.rfc-editor.org/info/rfc4013">http://www.rfc-editor.org/info/rfc4013</a>&gt;.

   [<a name="ref-RFC4422" id="ref-RFC4422">RFC4422</a>]  Melnikov, A., Ed., and K. Zeilenga, Ed., "Simple
              Authentication and Security Layer (SASL)", <a href="./rfc4422">RFC 4422</a>,
              DOI 10.17487/RFC4422, June 2006,
              &lt;<a href="http://www.rfc-editor.org/info/rfc4422">http://www.rfc-editor.org/info/rfc4422</a>&gt;.

   [<a name="ref-RFC5122" id="ref-RFC5122">RFC5122</a>]  Saint-Andre, P., "Internationalized Resource Identifiers
              (IRIs) and Uniform Resource Identifiers (URIs) for the
              Extensible Messaging and Presence Protocol (XMPP)",
              <a href="./rfc5122">RFC 5122</a>, DOI 10.17487/RFC5122, February 2008,
              &lt;<a href="http://www.rfc-editor.org/info/rfc5122">http://www.rfc-editor.org/info/rfc5122</a>&gt;.

   [<a name="ref-RFC5895" id="ref-RFC5895">RFC5895</a>]  Resnick, P. and P. Hoffman, "Mapping Characters for
              Internationalized Domain Names in Applications (IDNA)
              2008", <a href="./rfc5895">RFC 5895</a>, DOI 10.17487/RFC5895, September 2010,
              &lt;<a href="http://www.rfc-editor.org/info/rfc5895">http://www.rfc-editor.org/info/rfc5895</a>&gt;.




<span class="grey">Saint-Andre                  Standards Track                   [Page 23]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-24" id="page-24" href="#page-24" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


   [<a name="ref-RFC6121" id="ref-RFC6121">RFC6121</a>]  Saint-Andre, P., "Extensible Messaging and Presence
              Protocol (XMPP): Instant Messaging and Presence",
              <a href="./rfc6121">RFC 6121</a>, DOI 10.17487/RFC6121, March 2011,
              &lt;<a href="http://www.rfc-editor.org/info/rfc6121">http://www.rfc-editor.org/info/rfc6121</a>&gt;.

   [<a name="ref-RFC6122" id="ref-RFC6122">RFC6122</a>]  Saint-Andre, P., "Extensible Messaging and Presence
              Protocol (XMPP): Address Format", <a href="./rfc6122">RFC 6122</a>,
              DOI 10.17487/RFC6122, March 2011,
              &lt;<a href="http://www.rfc-editor.org/info/rfc6122">http://www.rfc-editor.org/info/rfc6122</a>&gt;.

   [<a name="ref-RFC6885" id="ref-RFC6885">RFC6885</a>]  Blanchet, M. and A. Sullivan, "Stringprep Revision and
              Problem Statement for the Preparation and Comparison of
              Internationalized Strings (PRECIS)", <a href="./rfc6885">RFC 6885</a>,
              DOI 10.17487/RFC6885, March 2013,
              &lt;<a href="http://www.rfc-editor.org/info/rfc6885">http://www.rfc-editor.org/info/rfc6885</a>&gt;.

   [<a name="ref-UTS39" id="ref-UTS39">UTS39</a>]    Unicode Technical Standard #39, "Unicode Security
              Mechanisms", edited by Mark Davis and Michel Suignard,
              &lt;<a href="http://unicode.org/reports/tr39/">http://unicode.org/reports/tr39/</a>&gt;.

   [<a name="ref-XEP-0004" id="ref-XEP-0004">XEP-0004</a>] Eatmon, R., Hildebrand, J., Miller, J., Muldowney, T., and
              P. Saint-Andre, "Data Forms", XSF XEP 0004, August 2007,
              &lt;<a href="http://xmpp.org/extensions/xep-0004.html">http://xmpp.org/extensions/xep-0004.html</a>&gt;.

   [<a name="ref-XEP-0016" id="ref-XEP-0016">XEP-0016</a>] Millard, P. and P. Saint-Andre, "Privacy Lists",
              XSF XEP 0016, February 2007,
              &lt;<a href="http://xmpp.org/extensions/xep-0016.html">http://xmpp.org/extensions/xep-0016.html</a>&gt;.

   [<a name="ref-XEP-0029" id="ref-XEP-0029">XEP-0029</a>] Kaes, C., "Definition of Jabber Identifiers (JIDs)",
              XSF XEP 0029, October 2003,
              &lt;<a href="http://xmpp.org/extensions/xep-0029.html">http://xmpp.org/extensions/xep-0029.html</a>&gt;.

   [<a name="ref-XEP-0030" id="ref-XEP-0030">XEP-0030</a>] Hildebrand, J., Millard, P., Eatmon, R., and P.
              Saint-Andre, "Service Discovery", XSF XEP 0030, June 2008,
              &lt;<a href="http://xmpp.org/extensions/xep-0030.html">http://xmpp.org/extensions/xep-0030.html</a>&gt;.

   [<a name="ref-XEP-0045" id="ref-XEP-0045">XEP-0045</a>] Saint-Andre, P., "Multi-User Chat", XSF XEP 0045,
              February 2012, &lt;<a href="http://xmpp.org/extensions/xep-0045.html">http://xmpp.org/extensions/xep-0045.html</a>&gt;.

   [<a name="ref-XEP-0048" id="ref-XEP-0048">XEP-0048</a>] Blackman, R., Millard, P., and P. Saint-Andre,
              "Bookmarks", XSF XEP 0048, November 2007,
              &lt;<a href="http://xmpp.org/extensions/xep-0048.html">http://xmpp.org/extensions/xep-0048.html</a>&gt;.

   [<a name="ref-XEP-0054" id="ref-XEP-0054">XEP-0054</a>] Saint-Andre, P., "vcard-temp", XSF XEP 0054, July 2008,
              &lt;<a href="http://xmpp.org/extensions/xep-0054.html">http://xmpp.org/extensions/xep-0054.html</a>&gt;.






<span class="grey">Saint-Andre                  Standards Track                   [Page 24]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-25" id="page-25" href="#page-25" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


   [<a name="ref-XEP-0060" id="ref-XEP-0060">XEP-0060</a>] Millard, P., Saint-Andre, P., and R. Meijer,
              "Publish-Subscribe", XSF XEP 0060, July 2010,
              &lt;<a href="http://xmpp.org/extensions/xep-0060.html">http://xmpp.org/extensions/xep-0060.html</a>&gt;.

   [<a name="ref-XEP-0065" id="ref-XEP-0065">XEP-0065</a>] Smith, D., Miller, M., Saint-Andre, P., and J. Karneges,
              "SOCKS5 Bytestreams", XSF XEP 0065, April 2011,
              &lt;<a href="http://xmpp.org/extensions/xep-0065.html">http://xmpp.org/extensions/xep-0065.html</a>&gt;.

   [<a name="ref-XEP-0077" id="ref-XEP-0077">XEP-0077</a>] Saint-Andre, P., "In-Band Registration", XSF XEP 0077,
              January 2012, &lt;<a href="http://xmpp.org/extensions/xep-0077.html">http://xmpp.org/extensions/xep-0077.html</a>&gt;.

   [<a name="ref-XEP-0106" id="ref-XEP-0106">XEP-0106</a>] Hildebrand, J. and P. Saint-Andre, "JID Escaping",
              XSF XEP 0106, June 2007,
              &lt;<a href="http://xmpp.org/extensions/xep-0106.html">http://xmpp.org/extensions/xep-0106.html</a>&gt;.

   [<a name="ref-XEP-0114" id="ref-XEP-0114">XEP-0114</a>] Saint-Andre, P., "Jabber Component Protocol",
              XSF XEP 0114, January 2012,
              &lt;<a href="http://xmpp.org/extensions/xep-0114.html">http://xmpp.org/extensions/xep-0114.html</a>&gt;.

   [<a name="ref-XEP-0144" id="ref-XEP-0144">XEP-0144</a>] Saint-Andre, P., "Roster Item Exchange", XSF XEP 0144,
              August 2005, &lt;<a href="http://xmpp.org/extensions/xep-0144.html">http://xmpp.org/extensions/xep-0144.html</a>&gt;.

   [<a name="ref-XEP-0166" id="ref-XEP-0166">XEP-0166</a>] Ludwig, S., Beda, J., Saint-Andre, P., McQueen, R., Egan,
              S., and J. Hildebrand, "Jingle", XSF XEP 0166,
              December 2009, &lt;<a href="http://xmpp.org/extensions/xep-0166.html">http://xmpp.org/extensions/xep-0166.html</a>&gt;.

   [<a name="ref-XEP-0191" id="ref-XEP-0191">XEP-0191</a>] Saint-Andre, P., "Blocking Command", XSF XEP 0191,
              July 2012, &lt;<a href="http://xmpp.org/extensions/xep-0191.html">http://xmpp.org/extensions/xep-0191.html</a>&gt;.

   [<a name="ref-XEP-0203" id="ref-XEP-0203">XEP-0203</a>] Saint-Andre, P., "Delayed Delivery", XSF XEP 0203,
              September 2009,
              &lt;<a href="http://xmpp.org/extensions/xep-0203.html">http://xmpp.org/extensions/xep-0203.html</a>&gt;.

   [<a name="ref-XEP-0220" id="ref-XEP-0220">XEP-0220</a>] Miller, J., Saint-Andre, P., and P. Hancke, "Server
              Dialback", XSF XEP 0220, August 2014,
              &lt;<a href="http://xmpp.org/extensions/xep-0220.html">http://xmpp.org/extensions/xep-0220.html</a>&gt;.

   [<a name="ref-XEP-0292" id="ref-XEP-0292">XEP-0292</a>] Saint-Andre, P. and S. Mizzi, "vCard4 Over XMPP",
              XSF XEP 0292, September 2013,
              &lt;<a href="http://xmpp.org/extensions/xep-0292.html">http://xmpp.org/extensions/xep-0292.html</a>&gt;.

   [<a name="ref-XML" id="ref-XML">XML</a>]      Bray, T., Paoli, J., Sperberg-McQueen, C., Maler, E., and
              F. Yergeau, "Extensible Markup Language (XML) 1.0 (Fifth
              Edition)", World Wide Web Consortium Recommendation
              REC-xml-20081126, November 2008,
              &lt;<a href="http://www.w3.org/TR/2008/REC-xml-20081126">http://www.w3.org/TR/2008/REC-xml-20081126</a>&gt;.





<span class="grey">Saint-Andre                  Standards Track                   [Page 25]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-26" id="page-26" href="#page-26" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


<span class="h2"><a class="selflink" name="appendix-A" href="#appendix-A">Appendix A</a>.  Differences from <a href="./rfc6122">RFC 6122</a></span>

   Based on consensus derived from working group discussion,
   implementation and deployment experience, and formal interoperability
   testing, the following substantive modifications were made from
   <a href="./rfc6122">RFC 6122</a>.

   o  Changed domainpart preparation to use IDNA2008 (instead of
      IDNA2003).

   o  Changed localpart preparation to use the UsernameCaseMapped
      profile of the PRECIS IdentifierClass (instead of the Nodeprep
      profile of stringprep).

   o  Changed resourcepart preparation to use the OpaqueString profile
      of the PRECIS FreeformClass (instead of the Resourceprep profile
      of stringprep).

   o  Specified that internationalized labels within domainparts must be
      U-labels (instead of "should be" U-labels).

   o  Specified that fullwidth and halfwidth characters must be mapped
      to their decomposition mappings (previously handled through the
      use of Normalization Form KC).

   o  Specified the use of Unicode Normalization Form C (instead of
      Unicode Normalization Form KC as specified in the Nodeprep and
      Resourceprep profiles of stringprep).

   o  Specified that servers must enforce the address-formatting rules.





















<span class="grey">Saint-Andre                  Standards Track                   [Page 26]</span></pre>
<hr class='noprint' style='width: 96ex;' align='left'/><!--NewPage--><pre class='newpage'><a name="page-27" id="page-27" href="#page-27" class="invisible"> </a>
<span class="grey"><a href="./rfc7622">RFC 7622</a>                   XMPP Address Format            September 2015</span>


Acknowledgements

   Thanks to Ben Campbell, Dave Cridland, Miguel Garcia, Joe Hildebrand,
   Jonathan Lennox, Matt Miller, Florian Schmaus, Sam Whited, and
   Florian Zeitz for their input during working group discussion.

   Dan Romascanu completed a helpful review on behalf of the General
   Area Review Team.

   During IESG review, Alissa Cooper, Brian Haberman, and Barry Leiba
   provided comments that led to improvements in the document.

   Thanks also to Matt Miller in his role as document shepherd, Joe
   Hildebrand in his role as working group chair, and Ben Campbell in
   his role as sponsoring Area Director.

   The author wishes to acknowledge Cisco Systems, Inc., for employing
   him during his work on earlier draft versions of this document.

Author's Address

   Peter Saint-Andre
   &amp;yet

   Email: peter@andyet.com
   URI:   <a href="https://andyet.com/">https://andyet.com/</a>

























Saint-Andre                  Standards Track                   [Page 27]

</pre><br />
    <span class="noprint"><small><small>Html markup produced by rfcmarkup 1.119, available from
      <a href="https://tools.ietf.org/tools/rfcmarkup/">https://tools.ietf.org/tools/rfcmarkup/</a>
    </small></small></span>
  </div>
</body>
</html>
